﻿Part Wizard Continued for KSP
Version 1.3.0.0



===================================================================================
Original text below from the original mod

http://forum.kerbalspaceprogram.com/threads/80124/

1. Features
2. Requirements
3. Supported Mods
4. Installation
5. Usage
   a. Part List Overview
   b. View Mode
      i. Sandbox Games
	  ii. Career and Science Games
   c. Deleting Parts
   d. Editing Symmetry
   e. Selecting Parts for Action Group Assignment
   f. Undoing an Operation
6. Contributors
7. Copyright and Licensing Information

1. Features

* Provides a list of parts with part highlighting for easier identification.
* Allows deleting of parts from the list on eligible[1] parts.
* Allows editing of symmetry[2] on eligible[3] parts.
* Shows either all parts or only those that are hidden from the editor's Parts List.
  * In career or science games, shows all parts that are currently unavailable.
    * Eligible[4] parts can be purchased directly from Part Wizard.
* Allows selecting parts from the list for action group assignments.
* Part List Filtering
  * Unlinked struts and fuel lines are highlighted in red.
  * Filter by part category.
  * Filter by specific resources.

[1] Parts eligible for deleting via Part Wizard are those that are not the "root" part and have no attached parts.
[2] Symmetry editing modifies the designated part, its counter parts and all symmetrical child parts.
[3] Parts eligible for "breaking" of symmetry must not include the "root" part as a counterpart or as a child part. 
[4] Parts eligible for purchase must have their technology requirement(s) researched and there must be sufficient funds to make the purchase.

2. Requirements

3. Supported Mods

   1. blizzy78's Toolbar plugin can be used as an alternative to the stock application launcher: http://blizzy.de/toolbar/download.html See the official Kerbal Space Program forum thread for more information: http://forum.kerbalspaceprogram.com/threads/60863/

4. Installation

    1. Place the PartWizard folder in to your Kerbal Space Program installation under the GameData folder.
	
5. Usage

The Part Wizard toolbar icon is only available in the Vehicle Assembly Building (VAB) or Space Plane Hangar (SPH) editors. The first time you start Kerbal Space Program with the Part Wizard plugin installed, you will need to configure your toolbar to display the Part Wizard icon. Once configured, clicking the Part Wizard toolbar icon will show Part Wizard, and clicking the toolbar icon again will hide it.

    a. Part List Overview

	The Part Wizard interface presents a list of parts that currently make up your vehicle. Mousing over each part on the list will highlight the part green. Parts with symmetry will also be highlighted green, all counterparts will be highlighted in yellow, and all child parts will be highlighted in white. At the bottom of the window is a status area that always shows the current total part count and, when mousing over a part, will show that part's internal name.

	b. View Mode

	   i. Sandbox Games
	   
	      There are four buttons at the top of the interface, "All", "Hidden", "Categories", and "Resources". These buttons control the current viewing mode, which is indicated by a depressed button with green text. 
		  "All" mode shows all of the current vessel's parts in the list. 
		  "Hidden" mode shows only those parts that have been hidden from the Parts List, as designated by either the part's configuration (.cfg) file or as modified by the Module Manager [1] plugin (or similar). Hidden mode is intended to allow the easy locating of parts that may have been made obsolete by the author.  
		  "Categories" mode is intended to show a list of part categories with toggles for each; if toggled, then parts in the toggled categories will be shown in the "All" & "Hidden" viewing mode. 
		  "Resources" mode will show a list of all the different resources on the current vessel; if toggled, then parts in the toggled resources will be shown in the "All" & "Hidden" viewing mode.  There is a special line listed, called "Parts without resources", which covers those parts which don't have any resources.

	   ii. Career and Science Games
	   
	      There are five buttons at the top of the interface: "All", "Hidden",  "Categories", and "Resources" and "Unavailable". These buttons control the current viewing mode, which is indicated by a depressed button with green text. 
		  "All" mode shows all of the current vessel's parts in the list. 
		  "Hidden" mode shows only those parts that have been hidden from the Parts List, as designated by either the part's configuration (.cfg) file or as modifid by the Module Manager [1] plugin (or similar). Hidden mode is intended to allow the easy locating of parts that may have been made obsolete by the author. 
		  "Categories" mode is intended to show a list of part categories with toggles for each; if toggled, then parts in the toggled categories will be shown in the "All" & "Hidden" viewing mode. 
		  "Resources" mode will show a list of all the different resources on the current vessel; if toggled, then parts in the toggled resources will be shown in the "All" & "Hidden" viewing mode.  There is a special line listed, called "Parts without resources", which covers those parts which don't have any resources.
		  "Unavailable" mode shows only the parts that aren't available due to not having researched the relevant technology and/or the part has not yet been purchased. The Unavailable mode will allow direct purchasing of parts that your space program is currently qualified to use, so long as the necessary funds are available. Additionally, in Unavailable mode, when possible there is a button at the bottom of the list that allows you to purchase all parts with a single command. NOTE: When parts are purchased your game will be saved immediately.
		  
	c. Deleting Parts

	Each active part in the Part Wizard list has a small button (labelled with a "X"). When this button is enabled, a part may be deleted by clicking the associated "X" button. The part will be removed immediately. If the part intended for deletion is symmetrical with other parts, ALL of its counterparts will also be deleted. (If this is not intended, see Breaking Symmetry, below.)

	d. Editing Symmetry

	Each active part in the Part Wizard list has a small button (labelled with a "B"). When this button is enabled, a part's symmetry may be edited by clicking the associated "B" button. The Symmetry Editor window will appear. Mousing over this window will highlight the relevant parts in cyan, and by default each counterpart will be automatically placed in a group. Clicking OK at this point will "break" symmetry for each part, all of its counterparts, and all symmetrical child parts will be converted to non-symmetrical parts and can be manipulated indvidually. However, parts can be moved between groups, groups can be removed and created. Clicking OK will apply the relevant changes, where groups with one part will be symmetrically "broken" and groups with more than one part will have a unique symmetry created for those parts. Note that non-symmetrical child parts are ignored by the Break Symmetry feature and will not be modified.

	e. Selecting Parts for Action Group Assignment
	
	When in the Action Group editor, each part on the parts list will become a button. Clicking this button will select that part (and it's symmetric counterparts) for action group assignment.
	
	f. Undoing an Operation

	Part Wizard utilizes the editor to enable its features and as such, its operations are undoable as normal. However, it may require more than one "undo" action to completely revert the actions due to the operations Part Wizard performs, especially when breaking symmetry.

	[1] Module Manager is a plugin for patching parts at load time, maintained by sarbian: http://forum.kerbalspaceprogram.com/threads/55219/

6. Contributors

Much appreciation and thanks to the contributors of Part Wizard, and if I missed anyone I'll be sure to update this in a future release.

  * sarbian for reviewing Part Wizard before the first release, making suggestions and continual help and advice.
  * m4v for allowing me to base the editor locking code on his mod, RCS Build Aid.
  * antgeth for the feature idea that became Symmetry Editor.
  * Vlos for the Action Group part selection feature.
  * Papa_Joe for adding support for the stock toolbar support contribution.
  * linuxgurugamer for general updates and finally adding the long-planned filtering features.
  * Everyone involved in with KSP that adds their ideas, time and thoughts to make a fun community for all of us to play with.
	
7. Copyright and Licensing Information

Part Wizard contains portions of "Toolbar" licensed under the terms of the "Simplified BSD License" and is copyright (c) Maik Schreiber. (http://opensource.org/licenses/BSD-2-Clause)
Part Wizard is licensed, as follows, under the terms of the "Modified BSD License": http://opensource.org/licenses/BSD-3-Clause

Copyright (c) 2014-2016, Eric Harris (ozraven)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the copyright holder nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL ERIC HARRIS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.